
(* File:    BuildRuntime.sml
   Author:  John Longley
   Date:    August 2008 

   Build file for SML implementation of game model and Lingay runtime.
*)


local open Pervasives in 

structure CBN_Games = CBN_Games (
	type ground = groundv ; 
        val blank = blankv ;
        val gToS = toString
        ) 

exception NotProd 

structure CBN_Thread = CBN_Thread (
	structure CBN_Games = CBN_Games
        val prodDecode = (fn prodv comps => comps | _ => raise NotProd)
        val prodEncode = prodv
        ) 

structure CBN_Control = CBN_Control (
        structure CBN_Games = CBN_Games
        )

structure CBV_Games = CBV_Games (
        structure CBN = CBN_Games
        structure CBN_Thread = CBN_Thread
        structure CBN_Control = CBN_Control
        ) 

structure Semantics = Semantics (
        structure CBV = CBV_Games
        ) 

end ;
