
functor Catchcont (
    type Z; type V; type XG; type XO; type XP; type YG; type YO; type YP
    ) = struct

type index = int ;

datatype ('a,'b) RQ = result of 'a | query of 'b 

datatype catchcontOmove =
    O1 of Z * index
  | O2 of XO * index
  | P3 of V * YG
  | P4 of YP
  | O5 
  | P6 of XG * index
  | P7 of XP * index
  | O8 
  | O9 of YO
  | P10 of XP * index   (* bang missing in definition! *)
  | O11 of XG
  | P12 of XG * index
  | P13 of XP * index
  | O14
  | O15 of YO

datatype catchcontPmove =
    P1 of XG * index
  | P2 of XP * index
  | O3 
  | O4 of YO
  | P5 of (V,Z) RQ
  | O6 of Z * index
  | O7 of XO * index
  | P8 of YG
  | P9 of YP
  | O10 of XO * index   (* bang missing in definition! *)
  | P11
  | O12 of Z * index
  | O13 of XO * index
  | P14 of V * YG
  | P15 of YP

type admin = {
     nextLeftIndex: int, 
     leftXiAssoc: (int*int) list, 
     leftRightAssoc: (int*int) list
     } ;

val initAdmin: admin = {
    nextLeftIndex = 2, 
    leftXiAssoc = [(1,0)], 
    leftRightAssoc = []
    } ;

fun addRight i (adm:admin) = {
    nextLeftIndex = #nextLeftIndex adm + 1,
    leftRightAssoc = (#nextLeftIndex adm,i):: #leftRightAssoc adm,
    leftXiAssoc = #leftXiAssoc adm
    } ;

fun addXi i (adm:admin) = {
    nextLeftIndex = #nextLeftIndex adm + 1,
    leftXiAssoc = (#nextLeftIndex adm,i):: #leftXiAssoc adm,
    leftRightAssoc = #leftRightAssoc adm
    } ;

datatype index' = Xi of int | Right of int

exception CatchcontError

fun getAssoc i (adm:admin) =
    (case Pervasives.optLookup (#leftXiAssoc adm) i of
	 SOME j => Xi j | NONE =>
	 (case Pervasives.optLookup (#leftRightAssoc adm) i of
	      SOME j => Right j | NONE => raise CatchcontError)) 

datatype status = INIT | RES of YG | RES' | QUE of XG | QUE' of admin

fun catchcontMove O5 INIT = (O3, INIT)
  (* result case *)
  | catchcontMove (P3(v,yg)) INIT = (P5 (result v), RES yg)
  | catchcontMove O8 (RES yg) = (P8 yg, RES')  
  | catchcontMove (O9 yo) RES' = (O4 yo, RES')
  | catchcontMove (P4 yp) RES' = (P9 yp, RES')
  | catchcontMove (O1(z,0)) RES' = (O6(z,0), RES')
  | catchcontMove (P6(xg,i)) RES' = (P1(xg,i), RES')
  | catchcontMove (O2(xo,i)) RES' = (O7(xo,i), RES')
  | catchcontMove (P7(xp,i)) RES' = (P2(xp,i), RES')
  (* query case *)
  | catchcontMove (O1(z,0)) INIT = (P5 (query z), INIT)
  | catchcontMove (O11 xg) INIT = (P11, QUE xg)
  | catchcontMove O14 (QUE xg) = (P1(xg,1), QUE' initAdmin)
  | catchcontMove (P3(v,yg)) (QUE' adm) = (P14(v,yg), QUE' adm)
  | catchcontMove (O15 yo) (QUE' adm) = (O4 yo, QUE' adm)
  | catchcontMove (P4 yp) (QUE' adm) = (P15 yp, QUE' adm)
  (* now the moves involving bang indices *)
  | catchcontMove (O1(z,0)) (QUE' adm) = (O12(z,0), QUE' adm)
  | catchcontMove (P12(xg,i)) (QUE' adm) = 
                  (P1(xg,#nextLeftIndex adm), QUE' (addRight i adm))
  | catchcontMove (O2(xo,i)) (QUE' adm) =
                  (case getAssoc i adm of
		       Xi j => (O10(xo,j), QUE' adm)
		     | Right j => (O13(xo,j), QUE' adm))
  | catchcontMove (P10(xp,i)) (QUE' adm) =
                  (P2(xp,#nextLeftIndex adm), QUE' (addXi i adm))
  | catchcontMove (P13(xp,i)) (QUE' adm) =
                  (P2(xp,#nextLeftIndex adm), QUE' (addRight i adm))
  | catchcontMove _ _ = raise CatchcontError

end ;